Package org.apache.catalina.valves

## Class ProxyErrorReportValve

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.valves.ValveBase
      - - org.apache.catalina.valves.ErrorReportValve
        - - org.apache.catalina.valves.ProxyErrorReportValve

All Implemented Interfaces:
  `javax.management.MBeanRegistration`, `Contained`, `JmxEnabled`, `Lifecycle`, `Valve`

    public class ProxyErrorReportValve
    extends ErrorReportValve

Implementation of a Valve that proxies or redirects error reporting to other urls.

This Valve should be attached at the Host level, although it will work if attached to a Context.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

`Lifecycle.SingleUse`

### Field Summary

Fields
`protected boolean` `usePropertiesFile` Use a properties file for the URLs.
`protected boolean` `useRedirect` Use a redirect or proxy the response to the specified location.

### Fields inherited from class org.apache.catalina.valves.ValveBase

`asyncSupported, container, containerLog, next, sm`

### Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase

`mserver`

### Fields inherited from interface org.apache.catalina.Lifecycle

`AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

### Constructor Summary

Constructors
`ProxyErrorReportValve()`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `getUsePropertiesFile()`
`boolean` `getUseRedirect()`
`protected void` `report​(Request request, Response response, java.lang.Throwable throwable)` Prints out an error report.
`void` `setUsePropertiesFile​(boolean usePropertiesFile)`
`void` `setUseRedirect​(boolean useRedirect)`

### Methods inherited from class org.apache.catalina.valves.ErrorReportValve

`findErrorPage, getPartialServletStackTrace, getProperty, invoke, isShowReport, isShowServerInfo, setProperty, setShowReport, setShowServerInfo`

### Methods inherited from class org.apache.catalina.valves.ValveBase

`backgroundProcess, getContainer, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setContainer, setNext, startInternal, stopInternal, toString`

### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

`destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister, unregister`

### Methods inherited from class org.apache.catalina.util.LifecycleBase

`addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, getThrowOnFailure, init, removeLifecycleListener, setState, setState, setThrowOnFailure, start, stop`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### useRedirect

    protected boolean useRedirect

Use a redirect or proxy the response to the specified location. Default to redirect.

#### usePropertiesFile

    protected boolean usePropertiesFile

Use a properties file for the URLs.

### Constructor Detail

#### ProxyErrorReportValve

    public ProxyErrorReportValve()

### Method Detail

#### getUseRedirect

    public boolean getUseRedirect()

Returns:
  the useRedirect

#### setUseRedirect

    public void setUseRedirect​(boolean useRedirect)

Parameters:
  `useRedirect` - the useRedirect to set

#### getUsePropertiesFile

    public boolean getUsePropertiesFile()

Returns:
  the usePropertiesFile

#### setUsePropertiesFile

    public void setUsePropertiesFile​(boolean usePropertiesFile)

Parameters:
  `usePropertiesFile` - the usePropertiesFile to set

#### report

    protected void report​(Request request,
                          Response response,
                          java.lang.Throwable throwable)

Description copied from class: `ErrorReportValve`
Prints out an error report.

Overrides:
  `report` in class `ErrorReportValve`
Parameters:
  `request` - The request being processed
  `response` - The response being generated
  `throwable` - The exception that occurred (which possibly wraps a root cause exception